<#assign extendsClass>TreeViewServiceBase</#assign>
<#ibizinclude>
../@MACRO/SERVICE/SERVICE_HEADER.ts.ftl
</#ibizinclude>

<#if ctrl.getPSDETreeNodes()??>
<#list ctrl.getPSDETreeNodes() as node>

    /**
     * ${node.getName()}节点标识
     *
     * @protected
     * @type {string}
     * @memberof ${srfclassname(ctrl.codeName)}Service
     */
	protected TREENODE_${node.getNodeType()?upper_case}: string = '${node.getNodeType()?j_string}';
</#list>
</#if>

    /**
     * 获取节点数据
     *
     * @param {string} action
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<HttpResponse>}
     * @memberof ${srfclassname(ctrl.codeName)}Service
     */
    public async getNodes(context:any = {}, data: any = {}, isloading?: boolean): Promise<HttpResponse> {
        const { srfparentkey, srfcat, srfnodeid, query }: any = data;
        const srfnodefilter: any = query || data.srfnodefilter;
        const list: any[] = [];
        const filter: any = {};
        <#--  BEGIN：逻辑代码  -->
        if (!srfnodeid || Object.is(srfnodeid, '#')) {
            <#if ctrl.isRootVisible()>
            await this.fill${srfclassname(ctrl.getRootPSDETreeNode().getNodeType()?lower_case)}Nodes(context, filter, list);
            return new HttpResponse(200, { records: list });
            <#else>
            srfnodeid = this.TREENODE_${ctrl.getRootPSDETreeNode().getNodeType()?upper_case};
            </#if>
        }

        let strTreeNodeId: string = srfnodeid;
        let strRealNodeId: string = '';
        let bRootSelect: boolean = false;
        let strNodeType: string | null = null;
        let strRootSelectNode: string = '';

        if (Object.is(strTreeNodeId, this.TREENODE_${ctrl.getRootPSDETreeNode().getNodeType()?upper_case})) {
            strNodeType = this.TREENODE_${ctrl.getRootPSDETreeNode().getNodeType()?upper_case};
            if (srfparentkey) {
                strRealNodeId = srfparentkey;
            }
        } else {
            let nPos = strTreeNodeId.indexOf(this.TREENODE_SEPARATOR);
            if (nPos === -1) {
                return new HttpResponse(200, null, { code: 100, message: '树节点 ' + strTreeNodeId + ' 标识无效' });
            }
            strNodeType = strTreeNodeId.substring(0, nPos);
			strRealNodeId = strTreeNodeId.substring(nPos + 1);
        }

        Object.assign(filter,
            {
                srfparentkey: srfparentkey,
                srfcat: srfcat,
                srfnodefilter: srfnodefilter,
                strRealNodeId: strRealNodeId,
                srfnodeid: srfnodeid,
                strNodeType: strNodeType
            }
        );

        // 分解节点标识
        const nodeid: string[] = strRealNodeId.split(this.TREENODE_SEPARATOR);
        for (let i = 0; i < nodeid.length; i++) {
            switch (i) {
                case 0:
                    Object.assign(filter, { nodeid: nodeid[0] });
                    break;
                case 1:
                    Object.assign(filter, { nodeid2: nodeid[1] });
                    break;
                case 2:
                    Object.assign(filter, { nodeid3: nodeid[2] });
                    break;
                case 3:
                    Object.assign(filter, { nodeid4: nodeid[3] });
                    break;
                default:
                    break;
            }
        }
        <#if ctrl.getPSDETreeNodes()??>
        <#list ctrl.getPSDETreeNodes() as node>
        if (Object.is(strNodeType, this.TREENODE_${node.getNodeType()?upper_case})) {
            await this.fill${srfclassname(node.getNodeType()?lower_case)}NodeChilds(context, filter, list);
            return new HttpResponse(200, { records: list });
        }
        </#list>
        </#if>
    <#--  END：逻辑代码  -->
        return new HttpResponse(500, null, { code: 100, message: '树节点' + strTreeNodeId + ' 标识无效' });
    }

<#--  BEGIN：填充代码  -->
<#if ctrl.getPSDETreeNodes()??>
<#list ctrl.getPSDETreeNodes() as node>
<#assign filtername="">
<#assign entityname="">
    /**
     * 填充 树视图节点[${node.getName()}]
     *
     * @protected
     * @param {any{}} context     
     * @param {*} filter
     * @param {any[]} list
     * @returns {Promise<any>}
     * @memberof ${srfclassname(ctrl.codeName)}Service
     */
    protected async fill${srfclassname(node.getNodeType()?lower_case)}Nodes(context: any = {}, filter: any, list: any[]): Promise<any> {
<#if node.getTreeNodeType() == 'STATIC'>
        const treeNode: any = {};
        Object.assign(treeNode, { text: '${node.getText()?j_string}' });
    <#if node.isEnableQuickSearch()>
        if (treeNode.srfnodefilter) {
            if (treeNode.text().toUpperCase().indexOf(filter.srfnodefilter.toUpperCase()) === -1) {
                return;
            }
        }
    </#if>
        Object.assign(treeNode, { srfmajortext: treeNode.text });
        let strNodeId: string = '${node.getNodeType()?j_string}';

    <#if node.getNodeValue()?? && node.getNodeValue()?length gt 0>
        Object.assign(treeNode, { srfkey: '${node.getNodeValue()?j_string}' });
        strNodeId += this.TREENODE_SEPARATOR;
        strNodeId += '${node.getNodeValue()?j_string}';

        <#if node.isAppendPNodeId()>
        strNodeId += this.TREENODE_SEPARATOR;
        strNodeId += filter.realnodeid;

        </#if>
        <#else>
        // 没有指定节点值，直接使用父节点值
        Object.assign(treeNode, { srfkey: filter.realnodeid });
        strNodeId += this.TREENODE_SEPARATOR;
        strNodeId += filter.realnodeid;

        </#if>
        Object.assign(treeNode, { id: strNodeId });

        <#if node.getPSSysImage()??>
        <#if node.getPSSysImage().getCssClass()?? && node.getPSSysImage().getCssClass()?length gt 0>
        Object.assign(treeNode, { iconcls: '${node.getPSSysImage().getCssClass()}' });

        <#else>
        Object.assign(treeNode, { icon: '${node.getPSSysImage().getImagePath()}' });

        </#if>
        </#if>
        <#if node.isEnableCheck()>
        Object.assign(treeNode, { enablecheck: true });

        </#if>
        <#if node.isDisableSelect()>
        Object.assign(treeNode, { disableselect: true });

        </#if>
        <#if node.isExpanded()>
        Object.assign(treeNode, { expanded: true });
        <#else>
        Object.assign(treeNode, { expanded: filter.isAutoexpand });
        </#if>
        <#if node.hasPSDETreeNodeRSs()>
        Object.assign(treeNode, { leaf: false });
        <#else>
        Object.assign(treeNode, { leaf: true });
        </#if>
        list.push(treeNode);
</#if>
<#if node.getTreeNodeType() == 'CODELIST' && node.getPSCodeList()??>
        <#if node.getPSCodeList().getCodeListType()?? && node.getPSCodeList().getCodeListType() == 'STATIC'>
        const codeListIems: any[] = await this.codeListService.getItems('${node.getPSCodeList().codeName}');
        <#elseif node.getPSCodeList().getCodeListType()?? && node.getPSCodeList().getCodeListType() == 'DYNAMIC'>
        const response: any = await this.codeListService.getItems('${node.getPSCodeList().codeName}');
        if (response.status === 200) {
            const codeListIems: any[] = response.data || [];
            let bFirst: boolean = true;
            codeListIems.forEach((item:any) => {
                const treeNode: any = {};
                Object.assign(treeNode, { text: item.text });
                <#if node.isEnableQuickSearch()>
                if(filter.srfnodefilter){
                    if(treeNode.getText().toUpperCase().indexOf(filter.getSrfnodefilter().toUpperCase())==-1)
                        continue;
                }
                </#if>
                Object.assign(treeNode, { srfmajortext: treeNode.text });
                let strNodeId: string = "${srfjavastring(node.getNodeType())}";
                Object.assign(treeNode, { srfkey: item.value });
                strNodeId += this.TREENODE_SEPARATOR;
                strNodeId += item.value;
                <#if node.isAppendPNodeId()>
                strNodeId += TREENODE_SEPARATOR;
                strNodeId += filter.getRealnodeid();
                </#if>
                Object.assign(treeNode, { id: strNodeId });
                <#if node.getPSSysImage()??>
                <#if node.getPSSysImage().getCssClass()?? && node.getPSSysImage().getCssClass()?length gt 0>
                Object.assign(treeNode, { iconcls: '${node.getPSSysImage().getCssClass()}' });
                <#else>
                Object.assign(treeNode, { icon: '${node.getPSSysImage().getImagePath()}' });
                </#if>
                </#if>
                <#if node.isEnableCheck()>
                Object.assign(treeNode, { enablecheck: true });
                </#if>
                <#if node.isDisableSelect()>
                Object.assign(treeNode, { disableselect: true });
                </#if>
                <#if node.isExpanded()>
                <#if node.isExpandFirstOnly()>
                Object.assign(treeNode, { expanded: bFirst });
                <#else>
                Object.assign(treeNode, { expanded: true });
                </#if>
                <#else>
                Object.assign(treeNode, { expanded: filter.isautoexpand });
                </#if>
                <#if node.hasPSDETreeNodeRSs()>
                Object.assign(treeNode, { leaf: false });
                <#else>
                Object.assign(treeNode, { leaf: true });
                </#if>
                list.push(treeNode);
                bFirst = false;
            });
        }
        </#if>
</#if>
<#if node.getTreeNodeType() == 'DE' && node.getPSDataEntity()??>
    <#assign filtername>${node.getPSDataEntity().codeName}SearchFilter</#assign>
    <#assign entityname>${node.getPSDataEntity().codeName}</#assign>
        const searchFilter: any = {};
    <#list ctrl.getPSDETreeNodeRSs() as noders>
    <#if noders.getChildPSDETreeNode().id == node.id>
    <#if noders.getParentFilter()?? && noders.getParentFilter()?length gt 0>
    <#assign pickupfield=noders.getParentFilter()>
        if (Object.is(filter.nodetype, this.TREENODE_${noders.getParentPSDETreeNode().getNodeType()?upper_case})) {
            Object.assign(searchFilter, { n_${pickupfield?lower_case}_eq: filter.nodeid<#if noders.getParentValueLevel() gt 1>${noders.getParentValueLevel()?c}</#if> });
        }
    <#elseif noders.getParentPSDER1N()??>
    <#assign pickupfield=noders.getParentPSDER1N().getPSPickupDEField()>
        if (Object.is(filter.nodetype, this.TREENODE_${noders.getParentPSDETreeNode().getNodeType()?upper_case})) {
            Object.assign(searchFilter, { n_${pickupfield.getName()?lower_case}_eq: filter.nodeid<#if noders.getParentValueLevel() gt 1>${noders.getParentValueLevel()?c}</#if> });
        }
    </#if>
    </#if>
    </#list>
        Object.assign(searchFilter, { total: false });
        Object.assign(searchFilter, { nodeid: filter.nodeid });
    <#if node.isEnableQuickSearch()>
        Object.assign(searchFilter, { query: filter.srfnodefilter });
    <#else>
        // 节点不支持搜索
    </#if>
        let bFirst: boolean = true;
        const response: any = await this.search${srfclassname(node.getNodeType()?lower_case)}(context, searchFilter, filter);
        if (response.status === 200 && response.data) {
            const records: any[] = response.data || [];
            records.forEach((entity: any) => {
                const treeNode: any = {};
                const strId: string = entity.${node.getPSAppDataEntity().getKeyPSAppDEField().codeName?lower_case};
                <#if node.getTextPSDEField()??>
                const strText: string = entity.${node.getTextPSDEField().codeName?lower_case};
                <#else>
                const strText: string = entity.${node.getPSAppDataEntity().getMajorPSAppDEField().codeName?lower_case};
                </#if>
                Object.assign(treeNode, { srfkey: strId });
                Object.assign(treeNode, { text: strText, srfmajortext: strText });
                let strNodeId: string = '${node.getNodeType()?j_string}';
                strNodeId += this.TREENODE_SEPARATOR;
                strNodeId += strId;
                <#if node.isAppendPNodeId()>
                strNodeId += this.TREENODE_SEPARATOR;
                strNodeId += filter.realnodeid;
                </#if>
                Object.assign(treeNode, { id: strNodeId });
                <#if node.getPSSysImage()??>
                <#if node.getPSSysImage().getCssClass()?? && node.getPSSysImage().getCssClass()?length gt 0>
                Object.assign(treeNode, { iconcls: '${node.getPSSysImage().getCssClass()}' });
                <#else>
                Object.assign(treeNode, { icon: '${node.getPSSysImage().getImagePath()}' });
                </#if>
                </#if>
                <#if node.isEnableCheck()>
                Object.assign(treeNode, { enablecheck: true });
                </#if>
                <#if node.isDisableSelect()>
                Object.assign(treeNode, { disableselect: true });
                </#if>
                <#if node.isExpanded()>
                <#if node.isExpandFirstOnly()>
                Object.assign(treeNode, { expanded: bFirst });
                <#else>
                Object.assign(treeNode, { expanded: true });
                </#if>
                <#else>
                Object.assign(treeNode, { expanded: filter.isautoexpand });
                </#if>
                <#if node.hasPSDETreeNodeRSs()>
                Object.assign(treeNode, { leaf: false });
                <#else>
                Object.assign(treeNode, { leaf: true });
                </#if>
                <#if node.getLeafFlagPSDEField()??>
                let objLeafFlag = entity.${node.getLeafFlagPSDEField().codeName?lower_case};
                if (objLeafFlag != null ) {
                    let strLeafFlag: string = objLeafFlag.toString().toLowerCase();
                    if (Object.is(strLeafFlag, '1') || Object.is(strLeafFlag, 'true')){
                        Object.assign(treeNode, { leaf: true });
                    }
                }
                </#if>
                <#if node.getPSDETreeNodeDataItems()??>
                <#list node.getPSDETreeNodeDataItems() as dataitem>
                <#if dataitem.getPSDEField()??>
                Object.assign(treeNode, { ${dataitem.name?lower_case}: entity.${dataitem.getPSDEField().codeName?lower_case} });
                </#if>
                </#list>
                </#if>
                list.push(treeNode);
                bFirst = false;
            });
        }
</#if>
        return list;
	}
<#if (filtername?length gt 0) && (entityname?length gt 0)>

    /**
     * 获取查询集合
     *
     * @protected
     * @param {*} [context={}]     
     * @param {*} searchFilter
     * @param {*} filter
     * @returns {any[]}
     * @memberof TestEnetityDatasService
     */
    protected async search${srfclassname(node.getNodeType()?lower_case)}(context: any = {}, searchFilter: any, filter: any): Promise<any> {
        await this.onBeforeAction('', context, null, false);
        if (!searchFilter.page) {
            Object.assign(searchFilter, { page: 0 });
        }
        if (!searchFilter.size) {
            Object.assign(searchFilter, { size: 9999 });
        }
        <#if appde?? && appde.getId() != node.getPSAppDataEntity().getId()>
        const service: any = await this.getService('${node.getPSAppDataEntity().codeName?lower_case}');
        <#else>
        const service: any = this.service;
        </#if>
        if (Util.isFunction(service['${node.getPSAppDEDataSet().getCodeName()}'])) {
            const response: HttpResponse = await service['${node.getPSAppDEDataSet().getCodeName()}'](context, searchFilter, false);
            if (response.status !== 200) {
                return response;
            }
            await this.onAfterAction('', context, response);
            return new HttpResponse(200, response.data || []);
        }
        await this.onAfterAction('', context);
        return new HttpResponse(500, null, { code: 100, message: '数据加载异常，${node.getPSAppDEDataSet().getCodeName()}行为不存在' });
    }
</#if>

    /**
     * 填充 树视图节点[${node.getName()}]子节点
     *
     * @private
     * @param {any{}} context         
     * @param {*} filter
     * @param {any[]} list
     * @returns {Promise<any>}
     * @memberof ${srfclassname(ctrl.codeName)}Service
     */
    private async fill${srfclassname(node.getNodeType()?lower_case)}NodeChilds(context: any = {}, filter: any, list: any[]): Promise<any> {
	<#if ctrl.getPSDETreeNodeRSs()??>
		if (!filter.srfnodefilter) {
		<#list ctrl.getPSDETreeNodeRSs() as noders>
		<#if noders.getParentPSDETreeNode().id == node.id>
		<#if noders.getSearchMode() == 1 || noders.getSearchMode() == 3>
			// 填充${noders.getChildPSDETreeNode().getName()}
			await this.fill${srfclassname(noders.getChildPSDETreeNode().getNodeType()?lower_case)}Nodes(context, filter, list);
		</#if>
		</#if>
		</#list>
		} else {
		<#list ctrl.getPSDETreeNodeRSs() as noders>
		<#if noders.getParentPSDETreeNode().id == node.id>
		<#if noders.getSearchMode() == 2 || noders.getSearchMode() == 3>
			// 填充${noders.getChildPSDETreeNode().getName()}
			await this.fill${srfclassname(noders.getChildPSDETreeNode().getNodeType()?lower_case)}Nodes(context, filter, list);
		</#if>
		</#if>
		</#list>
		}
	</#if>
	<#if node.isRootNode()>
        if (list.length > 0) {
            Object.assign(list[0], { selected: true })
        }
        return list;
	</#if>
	}

</#list>
</#if>
<#ibizinclude>
../@MACRO/SERVICE/SERVICE_BOTTOM.ts.ftl
</#ibizinclude>